You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

360 lines
17 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync\` must be installed to run mutt-wizard.\\n" && exit
  10. prefix="/usr/local"
  11. muttdir="$HOME/.config/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="$HOME/.local/share/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="$HOME/.mbsyncrc"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="$HOME/.cache/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="$HOME/.config/msmtp/config"
  22. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  23. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  24. do
  25. [ -f "$x" ] && sslcert="$x" && break
  26. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  27. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  28. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  29. getprofiles() { \
  30. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  31. printf "Creating profiles for \`%s\`..." "$title"
  32. msmtp_header="defaults
  33. auth on
  34. tls on
  35. tls_trust_file $sslcert
  36. logfile ~/.config/msmtp/msmtp.log
  37. "
  38. msmtp_profile="account $title
  39. host $smtp
  40. port $sport
  41. from $fulladdr
  42. user $login
  43. passwordeval \"pass mutt-wizard-$title\"
  44. $starttlsoff
  45. "
  46. mbsync_profile="IMAPStore $title-remote
  47. Host $imap
  48. Port $iport
  49. User $login
  50. PassCmd \"pass mutt-wizard-$title\"
  51. SSLType $ssltype
  52. AuthMech LOGIN
  53. CertificateFile $sslcert
  54. MaildirStore $title-local
  55. Subfolders Verbatim
  56. Path ~/.local/share/mail/$title/
  57. Inbox ~/.local/share/mail/$title/INBOX
  58. Flatten .
  59. Channel $title
  60. Expunge Both
  61. Master :$title-remote:
  62. Slave :$title-local:
  63. Patterns * !\"[Gmail]/All Mail\"
  64. Create Both
  65. SyncState *
  66. MaxMessages $maxmes
  67. ExpireUnread no
  68. # End profile
  69. "
  70. if [ "$accounttype" = "offline" ]; then
  71. mutt_profile="# vim: filetype=neomuttrc
  72. # muttrc file for account $title
  73. set realname = \"$realname\"
  74. set from = \"$fulladdr\"
  75. set sendmail = \"msmtp -a $title\"
  76. alias me $realname <$fulladdr>
  77. set folder = \"$maildir/$title\"
  78. set header_cache = $cachedir/$title/headers
  79. set message_cachedir = $cachedir/$title/bodies
  80. set mbox_type = Maildir
  81. set status_format="-%r-"$from": %D [Msgs:%?M?%M/?%m%?n? New:%n?%?o? Old:%o?%?d? Del:%d?%?F? Flag:%F?%?t? Tag:%t?%?p? Post:%p?%?b? Inc:%b?%?l? %l?]---(%s/%S)-%>-(%P)---"
  82. bind index,pager gg noop
  83. bind index,pager g noop
  84. bind index,pager M noop
  85. bind index,pager C noop
  86. bind index gg first-entry
  87. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  88. unmailboxes *
  89. "
  90. else
  91. mutt_profile="# vim: filetype=neomuttrc
  92. # muttrc file for account $title
  93. set realname = \"$realname\"
  94. set from = \"$fulladdr\"
  95. set sendmail = \"$prefix/bin/msmtp -a $title\"
  96. alias me $realname <$fulladdr>
  97. set folder = \"imaps://$fulladdr@$imap:$iport\"
  98. set imap_user = \"$login\"
  99. set header_cache = $cachedir/$title/headers
  100. set message_cachedir = $cachedir/$title/bodies
  101. set imap_pass = \"\`pass mutt-wizard-$title\`\"
  102. set status_format="-%r-"$from": %D [Msgs:%?M?%M/?%m%?n? New:%n?%?o? Old:%o?%?d? Del:%d?%?F? Flag:%F?%?t? Tag:%t?%?p? Post:%p?%?b? Inc:%b?%?l? %l?]---(%s/%S)-%>-(%P)---"
  103. set mbox_type = Maildir
  104. set ssl_starttls = yes
  105. set ssl_force_tls = yes
  106. bind index,pager gg noop
  107. bind index,pager g noop
  108. bind index,pager M noop
  109. bind index,pager C noop
  110. bind index gg first-entry
  111. unmailboxes *
  112. "
  113. fi
  114. printf "DONE.\\n"
  115. }
  116. askinfo() { \
  117. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  118. read -r fulladdr
  119. printf "\033[0m"
  120. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  121. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  122. read -r fulladdr
  123. printf "\033[0m"
  124. done
  125. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  126. search_query=$domain
  127. case "$domain" in
  128. protonmail.com|protonmail.ch|pm.me)
  129. search_query='protonmail.com' && break;;
  130. *)
  131. while : ; do
  132. printf "\nIs your email hosted with Protonmail? [yes/no] "
  133. read -r is_protonmail
  134. case $is_protonmail in
  135. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  136. [Nn][Oo]) break;;
  137. *) printf 'Please answer Yes or No'
  138. esac; done;
  139. esac
  140. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  141. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  142. if [ -z "$serverinfo" ]; then
  143. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  144. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  145. read -r imap
  146. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  147. read -r iport
  148. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  149. read -r smtp
  150. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  151. read -r sport
  152. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  153. else
  154. IFS=, read -r service imap iport smtp sport <<EOF
  155. $serverinfo
  156. EOF
  157. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  158. case "$service" in
  159. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  160. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  161. esac
  162. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  163. fi
  164. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  165. read -r realname
  166. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  167. read -r title
  168. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  169. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  170. read -r title
  171. printf "\033[0m"
  172. done
  173. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  174. read -r login
  175. printf "\033[0m"
  176. [ -z "$login" ] && login="$fulladdr"
  177. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  178. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  179. getpass
  180. getprofiles
  181. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  182. getaccounts
  183. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  184. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  185. echo "$msmtp_profile" >> "$msmtprc"
  186. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  187. case "$service" in
  188. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  189. esac
  190. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  191. echo "$mbsync_profile" >> "$mbsyncrc"
  192. notmuchauto
  193. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  194. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  195. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  196. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  197. }
  198. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  199. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  200. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  201. }
  202. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  203. pass insert "mutt-wizard-$title" && break; done ;}
  204. formatShortcut() { \
  205. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  206. echo "macro index,pager M$1 \";<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  207. echo "macro index,pager C$1 \";<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  208. done ;}
  209. tryconnect() { mkdir -p "$maildir/$title"
  210. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  211. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  212. printf "\033[32mMailboxes detected.\033[0m\\n"
  213. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  214. return 0
  215. else
  216. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  217. return 1
  218. fi ;}
  219. finalize() { \
  220. boxes="$(find "$maildir/$title/" -mindepth 1 -type d | sed "s/\ /\\\ /g;s/^.*\//=/;/=\(cur\|new\|tmp\)$/d")"
  221. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  222. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  223. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  224. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  225. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  226. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  227. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  228. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  229. echo "mailboxes $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  230. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  231. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  232. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  233. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  234. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  235. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  236. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  237. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  238. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  239. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  240. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  241. return 0
  242. }
  243. confirm() { printf "Do you want to %s? [yes/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  244. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  245. return 0 ;}
  246. pick() { printf "Select an accounts to %s:\\n" "$1"
  247. list
  248. read -r input
  249. [ -z "$input" ] && return 1
  250. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  251. [ -z "$title" ] && printf "Invalid response." && return 1
  252. return 0 ;}
  253. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  254. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  255. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  256. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  257. }
  258. choosecron() { ! pgrep cron >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  259. if crontab -l | grep mailsync >/dev/null; then
  260. echo "Active mail sync cronjob detected. Do you want to remove it?"
  261. printf "\033[36m\t"
  262. read -r rmyn
  263. printf "\033[0m"
  264. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  265. else
  266. echo "How many minutes between each mail sync?"
  267. printf "\033[36m\t"
  268. read -r minnum
  269. printf "\033[0m"
  270. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  271. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  272. read -r minnum
  273. printf "\033[0m"
  274. done
  275. (crontab -l; echo "*/$minnum * * * * $(type mailsync | cut -d' ' -f3)") | crontab - &&
  276. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  277. fi ;}
  278. asktype() { while : ; do
  279. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  280. read -r offnot
  281. case "$offnot" in
  282. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  283. [Nn][Oo]) accounttype="online" && break ;;
  284. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  285. esac; done ;}
  286. purge() { confirm "delete all account data" || exit
  287. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  288. crontab -l | sed '/mailsync/d' | crontab - >/dev/null
  289. echo "All configs and account settings have been purged."
  290. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  291. }
  292. notmuchauto() { \
  293. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  294. [ -f "$NOTMUCH_CONFIG" ] && return 0
  295. nmbasic="[database]
  296. path=$maildir
  297. [user]
  298. name=$realname
  299. primary_email=$fulladdr
  300. [new]
  301. tags=unread;inbox;
  302. ignore=
  303. [search]
  304. exclude_tags=deleted;spam;
  305. [maildir]
  306. synchronize_flags=true
  307. [crypto]
  308. gpg_path=$GPG"
  309. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  310. trap 'echo -e "\033[0m\n"; exit' STOP INT ABRT KILL
  311. case "$1" in
  312. ls) list ;;
  313. add) asktype && askinfo && tryconnect && finalize || delete ;;
  314. pass) pick "change the password of" && getpass ;;
  315. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  316. purge) purge ;;
  317. cron) choosecron ;;
  318. *) cat << EOF
  319. mw: mutt-wizard, auto-configure email accounts for mutt
  320. including downloadable mail with \`isync\`.
  321. Allowed options:
  322. add Add and autoconfigure an email address (9 max.)
  323. ls List configured accounts
  324. delete Pick an account to delete
  325. purge Delete all accounts and settings
  326. cron Enable or disable an autosync via cronjob
  327. all else Print this message
  328. NOTE: Once at least one account is added, you can run
  329. \`mbsync -a\` to begin downloading mail.
  330. EOF
  331. esac